
#include "main.h"

/* need to convert this to my language */
/* #define	TEST(m,cond)	G_STMT_START { failed = !(cond); \ //if (failed) \ //  { if (!m) \ //      g_print ("\n(%s:%d) failed for: %s\n", __FILE__, __LINE__, ( # cond )); \ //    else \ //      g_print ("\n(%s:%d) failed for: %s: (%s)\n", __FILE__, __LINE__, ( # cond ), (gchar*)m); \ //      exit(1); \ //  } \ //} G_STMT_END
*/

void indent(int level)   {
  time_t curtime = time(NULL);
  char *datetime = (char *) calloc(20, sizeof(char));
  /* Do I need the date and time here?? Can I get away with the time alone? */
  /* remove the year from this: strftime(datetime,20,"%a%Y%m%d%H%M%S", localtime(&curtime)); */
  strftime(datetime,20,"%a%m%d%H%M%S", localtime(&curtime));
  printf("%s:",datetime);
  free(datetime);
  while (level-- > 0) printf("%c",'.');
}

int increase (void ** pointer, int size, int element_size)
{
  int new_size = 0;
  void * localp = NULL;
  DB(10, ("increase"));
  localp = (* pointer);
  if ( 0 == size || NULL == localp )  {
    new_size = 1;
    if ( NULL == (localp = calloc( new_size, element_size) ) ) {
      DP(1, ("Could not allocate enough memory\n")); /* assert((*addr_string).address != NULL); */
      exit(0);
    }
  }
  else {
    new_size = size * 2;
    if ( NULL == (localp = realloc(localp, new_size * element_size) ) ) {
      DP(1, ("Could not allocate enough memory\n")); /* assert((*addr_string).address != NULL); */
      exit(0);
    }
    else {
      /* might get an error here about pointer conversion or pointer arithmetic */
      memset( &( (char *) localp)[size * element_size], '\0', (new_size - size) * element_size );
    }
  }
  (* pointer) = localp;
  DE(10, ("increase"));
  return new_size;
}


void write_strings(int sockfd, char * buf, int count, ...)
  {
  va_list list;
  int i = 0, bytes_to_send = 0;
  char * arg;
  va_start(list, count);

  if ('\0' != buf[0])	{
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send = strlen(buf) +1;
    }

  for (i = 0; i < count; i++)
    {
    arg = NULL;
    arg = va_arg(list, char*);
    sprintf(buf + bytes_to_send, "%s", arg);
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send += strlen(&buf[bytes_to_send]) + 1;
    }
  va_end(list);

  if ( WRITEBUFSIZE -1 < bytes_to_send) {
    DP(1,(" WRITEBUFSIZE -1 < bytes_to_send: %i <= %i", WRITEBUFSIZE -1, bytes_to_send));
  }
	
  if ((i = write(sockfd,buf, bytes_to_send)) < bytes_to_send) {DP(1,("Could not write to the socket: %s, bytes to send: %i\n", buf, bytes_to_send));}
  memset(buf,'\0',bytes_to_send+2);	bytes_to_send = 0;
  }


void write_integers(int sockfd, char * buf, int count, ...)
  {
  va_list list;
  int i = 0, bytes_to_send = 0;
  int arg;
  va_start(list, count);

  if ('\0' != buf[0])	{
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send = strlen(buf) +1;
    }

  for (i = 0; i < count; i++)
    {
    arg = 0;
    arg = va_arg(list, int);
    sprintf(buf + bytes_to_send, "%i", arg);
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send += strlen(&buf[bytes_to_send]) + 1;
    }
  va_end(list);
	
  if ( WRITEBUFSIZE -1 < bytes_to_send) {
    DP(1,(" WRITEBUFSIZE -1 < bytes_to_send: %i <= %i", WRITEBUFSIZE -1, bytes_to_send));
  }
  if ((i = write(sockfd,buf, bytes_to_send)) < bytes_to_send) {DP(1,("Could not write to the socket: %s, bytes to send: %i\n", buf, bytes_to_send));}
  memset(buf,'\0',bytes_to_send+2);	bytes_to_send = 0;
  }

void write_floats(int sockfd, char * buf, int count, ...)
  {
  va_list list;
  int i = 0, bytes_to_send = 0;
  double arg;
  va_start(list, count);

  if ('\0' != buf[0])	{
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send = strlen(buf) +1;
    }

  for (i = 0; i < count; i++)
    {
    arg = 0;
    arg = va_arg(list, double);
    sprintf(buf + bytes_to_send, "%0.2f", arg);
    DP(1,("About to print to socket, byte position: %i: %s", bytes_to_send, buf+bytes_to_send));
    bytes_to_send += strlen(&buf[bytes_to_send]) + 1;
    }
  va_end(list);
	
  if ( WRITEBUFSIZE -1 < bytes_to_send) {
    DP(1,(" WRITEBUFSIZE -1 < bytes_to_send: %i <= %i", WRITEBUFSIZE -1, bytes_to_send));
  }
  if ((i = write(sockfd,buf, bytes_to_send)) < bytes_to_send) {DP(1,("Could not write to the socket: %s, bytes to send: %i\n", buf, bytes_to_send));}
  memset(buf,'\0',bytes_to_send+2);	bytes_to_send = 0;
  }

int next_fld (struct pattern * patternptr ) {
  if (0 == patternptr->fempty || 0 == patternptr->fsize ) {
    patternptr->fempty = increase( (void *) &patternptr->flds,     patternptr->fsize, sizeof(struct field ) ) - patternptr->fsize;
    patternptr->fsize +=  patternptr->fempty;
  }
  patternptr->fempty--;
  memset( &patternptr->flds[ patternptr->fsize - patternptr->fempty - 1 ], '\0', sizeof(struct field) ) ;
  /* return &patternptr->flds[patternptr->fsize - patternptr->fempty-1]; */
  return patternptr->fsize - patternptr->fempty-1;
}

int next_stk (struct data * dataptr ) {
  if (0 == dataptr->sempty || 0 == dataptr->ssize) {
    dataptr->sempty = increase( (void *) &dataptr->stks, dataptr->ssize, sizeof(struct stock ) ) - dataptr->ssize;
    dataptr->ssize += dataptr->sempty;
  }
  dataptr->sempty--;
  memset(&dataptr->stks[ dataptr->ssize - dataptr->sempty - 1 ], '\0', sizeof(struct stock) ) ;
  return dataptr->ssize - dataptr->sempty - 1;
}

int next_trd (struct data * dataptr ) {
  if (0 == dataptr->tempty || 0 == dataptr->tsize) {
    dataptr->tempty = increase( (void *) &dataptr->trds, dataptr->tsize, sizeof(struct trade) ) - dataptr->tsize;
    dataptr->tsize += dataptr->tempty;
  }
  memset(&dataptr->trds[ dataptr->tsize - dataptr->tempty], '\0', sizeof(struct trade) ) ;
  dataptr->tempty--;
  return dataptr->tsize - dataptr->tempty - 1;
}



void printtree(int depth, struct data * dataptr, int trdindex, FILE * fd)
{
  int counter = 0;
  struct trade * trdptr;
  trdptr = (struct trade *) &((*dataptr).trds[trdindex]);
  if ( trdindex > (*dataptr).tsize - (*dataptr).tempty -1) {
    DP(1,("wrong index: %i\n", trdindex));
    exit(0);
  }
  if (fd) {
     for (counter = 0; counter <= depth; counter++) fprintf(fd,"\t");
     fprintf(fd, "price_type:%s trade_operator:%s trade_price:%.2f quantity:%i trigger_operator:%s trigger_price:%.2f trailing_operator:%s trailing_margin:%.2f status:%i {\n", trdptr->price_type, trdptr->trade_operator, trdptr->trade_price, trdptr->quantity, trdptr->trigger_operator, trdptr->trigger_price, trdptr->trailing_operator, trdptr->trailing_margin, trdptr->status );
     if (0 < trdptr->no_of_children ) {
       for (counter = 0; counter < trdptr->no_of_children; counter++)
         printtree(depth + 1, dataptr, trdptr->children[counter], fd);
     }
     for (counter = 0; counter <= depth; counter++) fprintf(fd,"\t");
     fprintf(fd, "}\n");
  }
  else {
     for (counter = 0; counter <= depth; counter++) printf("\t");
     printf("price_type:%s trade_operator:%s trade_price:%.2f quantity:%i trigger_operator:%s trigger_price:%.2f trailing_operator:%s trailing_margin:%.2f status:%i {\n", trdptr->price_type, trdptr->trade_operator, trdptr->trade_price, trdptr->quantity, trdptr->trigger_operator, trdptr->trigger_price, trdptr->trailing_operator, trdptr->trailing_margin, trdptr->status );
     if (0 < trdptr->no_of_children ) {
       for (counter = 0; counter < trdptr->no_of_children; counter++)
         printtree(depth + 1, dataptr, trdptr->children[counter], NULL);
     }
     for (counter = 0; counter <= depth; counter++) printf("\t");
     printf( "}\n");
  }
}

int compare_trades( struct data * stocks, struct data * currstocks,
		    int i, int c) {
  int a = 0, b =0, status = 1;
  struct trade * trd;
  struct trade * currtrd;
  trd = &(*stocks).trds[i];
  currtrd = &(*currstocks).trds[c];
  if ( i > (*stocks).tsize - (*stocks).tempty -1
     ||c > (*currstocks).tsize - (*currstocks).tempty -1
     ||trd->quantity != currtrd->quantity
     ||trd->trigger_price != currtrd->trigger_price
     ||trd->trade_price != currtrd->trade_price
     ||trd->trailing_margin != currtrd->trailing_margin
     || 0 != strcmp(trd->price_type, currtrd->price_type)
     || 0 != strcmp(trd->trigger_operator, currtrd->trigger_operator)
     || 0 != strcmp(trd->trade_operator, currtrd->trade_operator)
     || 0 != strcmp(trd->trailing_operator, currtrd->trailing_operator)
     ){
    return 0;
  }
  else {
    /* update status */
    if ( trd->status < currtrd->status ) {
     /* strcpy( trd->status, trd->status); */
      trd->status =  currtrd->status;
    }
    for (a = 0, b = 0;1 == status && a < trd->no_of_children && b < currtrd->no_of_children; a++, b++) {
      status = compare_trades(stocks, currstocks, trd->children[a], currtrd->children[b]);
    }
    return status;
  }
}

void compare_update(struct data * dataptr, struct data * currdataptr ){
 int i = 0, x = 0;
/* TODO change the compare_update and add number of data elements to compare */
  for (i = 0; i < (*dataptr).ssize - (*dataptr).sempty; i++) {
    for (x = 0; x < (*currdataptr).ssize - (*currdataptr).sempty; x++){
      if ( 0 == strcmp( (*dataptr).stks[i].localsymbol, (*currdataptr).stks[i].localsymbol) &&
	    -1 < (*dataptr).stks[i].roottrade ){
	compare_trades( dataptr, currdataptr,
			(*dataptr).stks[i].roottrade, (*currdataptr).stks[i].roottrade );
      }
    }
  }
}

int get_latest_file(char * latest_filename, char * subdir, time_t * mtimeptr)
{
  DIR             *dip;
  struct dirent   *dit;
  struct stat stat_buf;
  struct stat latest_stat_buf;
  char file_name[100];
  char * dir = strcat((char *)getcwd((char *)calloc(100, sizeof(char)), 99), subdir);

  DB(10,"get_latest_file");
  /* strategy_dir = strcat(getcwd(strategy_dir, 99), "/stops/");
   DP(10,("\tStop files stored at %s\n",latest_strategy_filename)); */
  mkdir(dir, DIR_MODE);

  /* while ((dip = opendir(dir)) == NULL) {DP(1,("Cannot open dir: %s",dir));} */
  if ((dip = opendir(dir)) == NULL) {DP(1,("Cannot open dir: %s",dir));return 0;}
  latest_stat_buf.st_ctime = 0;
  while ((dit = readdir(dip)) != NULL)
    {
    strcpy(file_name, dir);		strcat(file_name, dit->d_name);
    if (stat (file_name, &stat_buf) == 0 && S_ISREG (stat_buf.st_mode) && stat_buf.st_ctime > latest_stat_buf.st_ctime)
    	{
    	strcpy(latest_filename, file_name);/* strcpy(latest_file_name, dit->d_name); */
   	latest_stat_buf = stat_buf;
    	}
    }
  free(dir);
  if (closedir(dip) == -1) { DP(1,("Cannot close dir: %s",dir)); return 0; }
  if (latest_stat_buf.st_ctime > 0) {
     if ( mtimeptr && (*mtimeptr) >= latest_stat_buf.st_mtime ) {
        DP(10,("latest file: %s",latest_filename));
        DE(10,"get_latest_file");
        return 2;
     }
    if (mtimeptr) (*mtimeptr) = latest_stat_buf.st_mtime;
    /* latest_strategy_filename = strcat(latest_strategy_filename, latest_file_name); */
    DP(1,("latest file: %s",latest_filename));
    DE(10,"get_latest_file");
    return 1;
  }
  else {
    DE(10,"get_latest_file");
    DE(10,"could not find the latest file");
    exit(0);
    return 0;
  }
}

void get_strategy( struct data * dataptr, char * dir, time_t * mtimeptr)
{
  /* parser and lexer initializations from here */
  void* pParser = (void *) stgparseAlloc (malloc); 
  /* cannot have a memory location as the value there changes when the next token is reached */
  /* when the parser tries to read the value from that location, it gets the next token */
  /* char* tokvalue = (char *) calloc (100, sizeof(char)); */
  struct stgptokenvalue tok;
/*  char tokvalue[10]; */
  int token = 0, status = 0; /* , idx = 0; */
  Scanner scanner;
  char strategy_file[100];
   
  DB(10, ("get_strategy"));
  DP(10, ("In the application to test out the stock structures"));
  memset(strategy_file, '\0', 100);

  /* (Do I ??) have to worry about freeing this stuff too!!
     this memory stays for the lifecycle of the program */
  /* (*dataptr).ssize = next_stk ( dataptr ); */

  memset((char*) &scanner, '\0', sizeof(scanner));
  memset((char*) &tok, '\0', sizeof(tok));
/*  scanner.fd = 0; */
  if (1 == ( status = get_latest_file(strategy_file,dir, mtimeptr) ) ) {
    DP(10,("reading file: %s for strategy",strategy_file));
  }
  else if ( 2 == status) {
    stgparseFree(pParser, free ); 
    DP(10,("already have the latest strategy file"));
    DE(10, ("get_strategy"));
    return;
  }
  (*dataptr).sempty = (*dataptr).ssize;
  (*dataptr).tempty = (*dataptr).tsize;
  scanner.fd = open(strategy_file, O_RDONLY);
  while((token = stgscan(&scanner)) != EOF){
/*    while (tok.size < scanner.cur - scanner.tok ) 
      tok.size = increase( (void *) &tok.value, tok.size, sizeof(char) ) ; */
    /* disregarding NUMACCTS here */
    if ( TOKACCOUNT == token) {
      if( '\0' == dataptr[0].account[0] || 
	  0 == strncasecmp( (char *) scanner.tok, dataptr[0].account, scanner.cur-scanner.tok) ) 
	tok.actidx = 0;
      else tok.actidx = 1;
    }
    if (TOKVALUESIZE < scanner.cur - scanner.tok ) {
    	DP(1,("token %d value (%.*s) greater than 100 chars\n", token, scanner.cur - scanner.tok, scanner.tok));
	exit(0);
    }
    strncpy(tok.value, (char *)scanner.tok, scanner.cur - scanner.tok );
    tok.value[ scanner.cur - scanner.tok ] = '\0'; 
    DP(10,("%d\t%.*s\n", token, scanner.cur - scanner.tok, scanner.tok));
    DP(10,("%d\n", token));
    stgparse( pParser, token, tok, dataptr );  
  }
  /* need to destroy the scanner as: yylex_destroy(scanner); */

  /* First input: 
      15 / 5 */

  stgparse (pParser, 0, tok, dataptr );
  stgparseFree(pParser, free ); 
  free(scanner.bot);
  close(scanner.fd);

  /* walk and print the tree 
  for(counter = 0; counter < data.ssize; counter++) {
    printtree(1, stks[counter].stack, NULL);
    }
*/
  DE(5, ("get_strategy"));
}
/* the following code for testing the parser behaviour */
/* to test the scanner behaviour use test_scanner.re */
  /* test ibparse */
  /* test_ibparser(&dataptr[0]); */



void  write_current_state(struct data * dataptr) {
  int actidx = 0, i = 0;
  FILE * statefd = NULL;
  char *state_file = strcat(getcwd((char *)calloc(100, sizeof(char)), 99), "/currentstate/");
  /* time_t curtime = time (NULL); */
#include <sys/timeb.h>
  struct timeb curtime ;
/* Fill in TIMEBUF with information about the current time.  */
  /* using millitime to take care of the scenario where I spit out a file within the same sec */
  ftime(&curtime);
  mkdir(state_file,DIR_MODE);
  strftime(&state_file[strlen(state_file)],29,"%Y%m%d_%a.%H%M%S", localtime(&curtime.time));
  sprintf(&state_file[strlen(state_file)],".%i.txt",curtime.millitm);
  while (NULL == (statefd = fopen(state_file, "a+")) ) {
    perror("open");
    DP(10,("Could not open file: %s. Trying again..",state_file));
    /* exit(-1); */
  }
  for (actidx = 0; actidx < NUMACCTS; actidx++) {
    for (i = 0; i < dataptr[actidx].ssize - dataptr[actidx].sempty; i++){
      fprintf(statefd, "%s:%s sectype:%s\n", dataptr[actidx].account, dataptr[actidx].stks[i].localsymbol,dataptr[actidx].stks[i].sectype);
      printf( "%s:%s sectype:%s\n", dataptr[actidx].account, dataptr[actidx].stks[i].localsymbol,dataptr[actidx].stks[i].sectype);
      DP(10,("localsymbol: %s", dataptr[actidx].stks[i].localsymbol));
      printtree( 1, &dataptr[actidx], dataptr[actidx].stks[i].roottrade, statefd );
      printtree( 1, &dataptr[actidx], dataptr[actidx].stks[i].roottrade, NULL );
    } /* for (i = 0; i < stocks->ssize - stocks->sempty; i++) */
  } /* for (actidx = 0; actidx < NUMACCTS; actidx++)  */

  fclose (statefd);
  free (state_file);
}

void email_current_state () {
  int status = 0;
  char strategy_file[100];
  time_t curtime = time (NULL);
  /* why am I using a char array above and a calloc below? for kicks?? */
  char *mail_file_name = strcat(getcwd((char *)calloc(100, sizeof(char)), 99), "/outbox/");
  int inF, ouF;
  char line[1024];
  int bytes;

  mkdir(mail_file_name,DIR_MODE);
  strftime(&mail_file_name[strlen(mail_file_name)],29,"%Y%m%d_%a.%H%M%S.txt", localtime(&curtime));
  memset(strategy_file,'\0',100);

  if (1 == ( status = get_latest_file(strategy_file,"/currentstate/", NULL) ) ) {
    DP(10,("emailing file: %s for strategy",strategy_file));
  }

  while (-1 == (inF = open(strategy_file, O_RDONLY)) ) {
    perror("open");
    DP(10,("Could not open file: %s. Trying again..",strategy_file));
    /* exit(-1); */
  }

  /* check out section 3.4 and 4.5 of "Advanced Programming in the UNIX env" */
  /* interesting difference: open vs fopen. open is more versatile?? */
  if((ouF = open(mail_file_name, O_WRONLY | O_CREAT, FILE_MODE)) == -1) {
    perror("open");
    exit(-1);
  }

  while((bytes = read(inF, line, sizeof(line))) > 0)
    write(ouF, line, bytes);

  close(inF);
  close(ouF);
  free(mail_file_name);
}

/* use tcpclient.c to test or run this subroutine independently */
void send_close_window_message ()
	{
	struct sockaddr_in	serv;
	char			request[20];/*, reply[20];*/
	int			sockfd = 0;/*, n;*/
	long int		last_time;
#define	CLOSE_WINDOW_SERV_PORT	6003	/* port used by the close_windows.c tcp server program*/
	DB(10,"send_close_window_message");

	if ( (sockfd = socket(PF_INET, SOCK_STREAM, 0)) < 0)	{DP(1, ("%s", "socket error"));}

	memset(&serv, '\0', sizeof(serv));
	serv.sin_family		 = AF_INET;
	serv.sin_addr.s_addr = inet_addr("127.0.0.1");
	serv.sin_port		 = htons(CLOSE_WINDOW_SERV_PORT);

	if (connect(sockfd, (struct sockaddr *) &serv, sizeof(serv)) < 0) {
		DP(1, ("%s", "Could not connect to close_windows socket at 127.0.0.1:6003"));
		return;
		}

	/* form request[] ... */
	last_time = time(NULL);
	DP(1, ("before sending: %li\n", last_time));

	/* form request[] ... */
	memset(request, '\0', 20);
	strcpy(request,"CLOSE_WINDOW\r\n");
	DP(10, ("%s", "Before write"));
	if (write(sockfd, request, 20) != 20) {DP(1, ("%s", "Could not write the message CLOSE_WINDOW to the socket"));}
	DP(10, ("%s", "After write"));
	/*if ( (n=read(sockfd, reply, 20)) < 0)	{DP(1, ("%s", "Could not read from the socket"));}printf("read error"); process "n" bytes of reply[] ... 	printf("%s\n",reply);*/
	/*DP(1, ("%s", "After read"));*/
	/*  close socket immediately */
	/* removing shutdown as in Pg. 189 of Richard Stevens
	 it's ok if this message is triggered, as SO_LINGER of the server is killing this socket immediately
	 if (shutdown(sockfd, SHUT_RDWR) < 0) {DP(1, ("%s", "Could not shutdown close_windows socket"));}
	 */
	close(sockfd);

	DE(10,"send_close_window_message");
	}

void read_strategy( struct data * dataptr)
{
  struct data currdataptr[NUMACCTS];
  int i = 0, actidx = 0;
  time_t mtime = dataptr[0].stks_mtime;
  memset( (char *) &currdataptr, '\0', sizeof(struct data) * NUMACCTS);
  DB(10, ("read_strategy"));
  DP(10, ("In the application to test out the stock structures"));
  
/*  get_initial_strategy(dataptr); */
  /* for the config file
   	add the lexer here
  	add the parser here */
  get_strategy(dataptr, "/strategy/", &dataptr[0].stks_mtime);
  /* do not do anything if the mtime of the strategy file has not changed */
  /* making the initial strategy file as the driver for any change */
  /* avoid the state file reading junk or vi .swp files and erroring out while I am looking at the state file */
  if ( mtime == dataptr[0].stks_mtime) return;

  /* for the state file
   	add the lexer here
  	add the parser here */
  for(actidx = 0;actidx < NUMACCTS; actidx++) {
    dataptr[actidx].stks_mtime = dataptr[0].stks_mtime;
    currdataptr[actidx].stks_mtime = dataptr[actidx].stks_mtime;
    strcpy(currdataptr[actidx].account, dataptr[actidx].account);
    for (i = 0; i < dataptr[actidx].ssize - dataptr[actidx].sempty; i++){
      DP(1,("localsymbol: %s", dataptr[actidx].stks[i].localsymbol));
      if (dataptr[actidx].request_market_data && dataptr[actidx].sockfd) write_integers(dataptr[actidx].sockfd, dataptr[actidx].wbuf,3,CANCEL_MKT_DATA,i,0);
      if ( 0 < (dataptr[actidx].tsize - dataptr[actidx].tempty) &&
           -1 < dataptr[actidx].stks[i].roottrade
	  ) printtree(1, dataptr, dataptr[actidx].stks[i].roottrade, NULL);
    }
    dataptr[actidx].request_contract_details = 0;
    dataptr[actidx].request_market_data = 0;
  }
  get_strategy(currdataptr , "/currentstate/", NULL);
 /* compare the config file tree and the state file tree
   	if they r equal, update the statuses of the config file tree with that of the state file tree */
  for(i = 0;i < NUMACCTS; i++) {
    compare_update(&dataptr[i],&currdataptr[i]); 
  }
 /* for the socket read
   	add the lexer here
   	add the parser here
	*/

  for(i = 0;i < NUMACCTS; i++) {
    free(currdataptr[i].trds);
    free(currdataptr[i].stks);
  }
  DE(10, ("read_strategy"));
}

int test_ibparser(struct data * dataptr)
{
  void* pParser = ibparseAlloc (malloc);
  struct tokenvalue tok;
  int i = 0;

  /* First input: 
      15 / 5
                                */
  tok.value[0] = '1';
  dataptr->cptrn = 1;
  /* ibparse (pParser, TOKNEXT_VALID_ID, tok,dataptr); */
  ibparse (pParser, TOKNEXT_VALID_ID, tok,dataptr);
  i = ibparse_next_action_is_a_shift(pParser);
  DP(1,("i: %i",i)); 

  ibparse (pParser, TOKVALUE, tok,dataptr);
  i =ibparse_next_action_is_a_shift(pParser);
  DP(1,("i: %i",i));

  ibparse (pParser, TOKVALUE, tok,dataptr);
  i = ibparse_next_action_is_a_shift(pParser);
  DP(1,("i: %i",i)); 

  DP(1,("end of the previous message")); 
  DP(1,("dataptr->cptrn: %i",dataptr->cptrn)); 
  /* ibparse (pParser, TOKVALUE, tok,dataptr);  */
  DP(1,("freeing the parser")); 
  ibparse (pParser, 0, tok,dataptr); 
  DP(1,("dataptr->cptrn: %i",dataptr->cptrn)); 
  /* dataptr->cptrn = 1; */
  /* ibparse (pParser, TOKNEXT_VALID_ID, tok,dataptr); */
  ibparse (pParser, TOKNEXT_VALID_ID, tok,dataptr);
  ibparse (pParser, TOKVALUE, tok,dataptr);
  ibparse (pParser, TOKVALUE, tok,dataptr);
  ibparse (pParser, 0, tok,dataptr);  
  DP(1,("freeing the parser"));
  DP(1,("dataptr->cptrn: %i",dataptr->cptrn));


  /*  Second input:
        50 + 125
                               */

  /* Parse (pParser, 0, 0); */

  /*  Third input:
        50 * 125 + 125
                               */

  ibparseFree(pParser, free );

  return 0;
}


